Fix ordering in ApplicationHelper method principals_options_for_select
Status: New Start date:  
Assignee:  % Done: 0%

Category: Issues Estimated time: 0.00 hour

Target version:    

Description

We experienced problems on assigning issues recently.

We have a lot of members for some projects (about 30+ people each project).

User's name (first name & last name) are in non-English.

The problem is seems Redmine does not sort users in Assignee drop down while editing a issue, so it is very hard to find a user.

We are wondering if Redmine could provide a search box like adding watchers do.

History

#1 - 2014-04-23 09:36 - Jan Niggemann (redmine.org team member)

I think that ApplicationHelpers' method principals_options_for_select does sort, perhaps it's not properly working for foreign locales?

source:trunk/app/helpers/application_helper.rb#L375

#2 - 2014-04-23 13:26 - Joseph Wang

Jan Niggemann (redmine.org team member) wrote:

I think that ApplicationHelpers' method principals_options_for_select does sort, perhaps it's not properly working for foreign locales?

source:trunk/app/helpers/application_helper.rb#L375

 My locale is zh. User names are in Chinese.

#3 - 2014-04-23 16:30 - Joseph Wang

Jan Niggemann (redmine.org team member) wrote:

I think that ApplicationHelpers' method principals_options_for_select does sort, perhaps it's not properly working for foreign locales?

source:trunk/app/helpers/application_helper.rb#L375

 I totally don't have experience on Ruby, but seems this line is a problem:

collection.sort.each do |element|

collection contains User objects? Doesn't the sort method sort elements by address? or something else?    

I googled "Ruby sort collection" and got this:

http://stackoverflow.com/questions/882070/sorting-an-array-of-objects-in-ruby-by-object-attribute

Then I changed the line to following:

collection.sort_by{|user|user.lastname}.each do |element|

 Then glad to see it works. Redmine sorted Assignees by last name even in Chinese.

Hope that won't bring side effect.

#4 - 2014-04-23 22:43 - Jan Niggemann (redmine.org team member)

- Subject changed from Needs easy way to pick assignee to Fix ordering in ApplicationHelper method principals_options_for_select

- Category set to Issues

#5 - 2014-04-23 22:43 - Jan Niggemann (redmine.org team member)

- Tracker changed from Feature to Patch
#6 - 2014-05-21 10:01 - Toshi MARUYAMA

"User" has order attribute.

source:tags/2.5.1/app/models/user.rb#L24

#7 - 2022-02-17 09:40 - Mr. Míng

+1. This problem is very unbearable.

Currently, I must configure to displaying login as user name - which is hard to read. But, sorting by user `login` is what we need - at least for Chinese.
